=== debian/changelog ===
dpdk (16.11-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Santiago R.R. <santiagorr@riseup.net>  Wed, 12 Apr 2017 14:47:47 +0200

dpdk (16.11-1) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * Merge stable release 16.11 and adapt patches
    - imported latest stable release from dpdk-16.11.tar.gz
      stable release changelog at
      http://dpdk.org/doc/guides-16.11/rel_notes/release_16_11.html
    - Delete patches that are upstream:
      - d/p/dpdk-dev-ppc-enable-*
      - d/p/dpdk-dev-v2-*-4*
      - d/p/rte-devel-build-env.patch
      - d/p/rte-compile-pre-cppflags.patch
      - d/p/make-load-devel-config-not-to-appear-as-executable.patch
      - d/p/dpdk-dev-doc-fix-old-dpdk-nic-bind.py-references.patch
      - d/p/fix-double-license-info.patch
  * Added changes
    - add qede pmd now built by default
    - add new librte-net library
    - bump librte-eal version from 2 to 3 as package rename transition
    - bump librte-cryptodev version from 1 to 2 as package rename transition
    - bump librte-ethdev version from 4 to 5 and the library rename that was
      made upstream as package rename transition
    - update symbols files to match the new release
    - make autotest dep8 test always pass (failed fatally on e.g. LP).
      We want to stabilize and get more logs of different environments before
      we can enable it as a gating test.

  [ Luca Boccassi ]
  * Set maintainer to pkg-dpdk-dev alioth list
  * Make dpdk suggest dpdk-doc (Closes: #847626)

 -- Luca Boccassi <luca.boccassi@gmail.com>  Fri, 16 Dec 2016 18:19:07 +0000

dpdk (16.07.2-1~git1) UNRELEASED; urgency=medium

  * Merge stable release 16.07.2 and adapt patches
    - imported latest stable release from dpdk-16.07.2.tar.gz
      stable release changelog at
      http://dpdk.org/doc/guides-16.07/rel_notes/release_16_07.html
    - Deleted:
      - d/p/dpdk-dev-v2-kni-fix-build-with-kernel-4.8.patch
      - d/p/fix-unusual-interpreter.patch
      - d/p/dpdk-dev-examples-ip_pipeline-fix-pmd-driver-parameter.patch
      - d/p/dpdk-dev-kni-fix-build-with-kernel-4.9.patch
      - d/p/dpdk-dev-ppc-enable-7-7-examples-ip_pipeline-fix-lcore-mapping-for-
        ppc64.patch
    - Refreshed (only offset changes)
      - d/p/dpdk-dev-ppc-enable-1-7-lpm-add-AltiVec-for-ppc64.patch
      - d/p/dpdk-dev-ppc-enable-2-7-acl-add-AltiVec-for-ppc64.patch
      - d/p/dpdk-dev-ppc-enable-4-7-sched-enable-on-ppc64le.patch
      - d/p/dpdk-dev-ppc-enable-6-7-config-enable-packet-framework-on-
        ppc64le.patch
      - d/p/dpdk-dev-v2-2-4-doc-rendering-and-installation-of-man-pages.patch
      - d/p/dpdk-dev-v2-3-4-doc-add-basic-invocation-info-for-dpdk-pmdinfo.patch
      - d/p/dpdk-dev-v2-4-4-doc-add-basic-invocation-info-for-dpdk-devbind.patch

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 05 Dec 2016 07:08:01 +0100

dpdk (16.07-3) unstable; urgency=medium

  * Set myself as maintainer until the mailing list ACL problem
    is resolved. (Closes: #843688)

 -- Luca Boccassi <luca.boccassi@gmail.com>  Fri, 25 Nov 2016 23:01:34 +0000

dpdk (16.07-2) unstable; urgency=low

  * Team upload.

  [ Christian Ehrhardt ]
  * Fix d/p/fix-vhost-user-socket-permission.patch for dpdk 16.07
    server/client sockets.
  * d/control add python-elftools and hwdata dependencies to dpdk for the tool
    dpdk-pmdinfo.
  * d/rules utilize RTE_EAL_PMD_PATH to autoload pmd drivers
    - d/dpdk-doc.README.Debian document usage of RTE_EAL_PMD_PATH
    - d/control let the runtime of dpdk recommend the pmd drivers to make them
      available for auto-probing devices.
  * d/rules support DEB_BUILD_OPTIONS parallel
  * d/rules bundle autotest as it is ready after build into dpdk-dev
    to make it available for autopkgtest and likewise developers.
  * enable dpdk autotests
    - d/t/test-autotest enable autotests as dep8 test. These fail in many
      build environments, so put them in an adt where required characteristics
      can be specified

  [ Gowrishankar Muthukrishnan ]
  * d/p/dpdk-dev-examples-ip_pipeline-fix-pmd-driver-parameter.patch to make
    ip_pipeline work properly with -d eal parameter
  * Update to d/p/dpdk-dev-examples-ip_pipeline-fix-pmd-driver-parameter.patch
    fixing dl_open issues.

  [ Santiago R.R. ]
  * debian/rules: Only export hardening related building HOST_/EXTRA flags
    when dpkg-dev < 1.18.11. On newer dpkg-dev versions, dpkg-buildflags
    handle them directly and are injected by gcc (6.x). Closes: #843685.

  [ Luca Boccassi ]
  * Fix DKMS build to use the requested kernel version rather than the running
    one. (Closes: #843864)
  * Fix kernel modules build failures due to the new -fPIE default by passing
    -fno-PIE.
  * Backport dpdk-dev-kni-fix-build-with-kernel-4.9.patch to fix kernel modules
    build failures on Linux 4.9.
  * Mark dpdk-doc as Multi-Arch: foreign
  * Finalize changelog for upload to unstable.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Mon, 14 Nov 2016 18:27:53 +0000

dpdk (16.07-1) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * Merge with upstream DPDK 16.07 release
  * Cleanup Lintian Warnings
    - d/p/fix-unusual-interpreter.patch fixes "W: dpdk-doc:
      unusual-interpreter"
    - d/p/fix-double-license-info.patch fixes "W: dpdk-rte-kni-dkms:
      extra-license-file"
  * Renamed d/p/ubuntu-fix-vhost-user-socket-permission.patch to
    d/p/fix-vhost-user-socket-permission.patch
  * Add lintian-overrides for: E: dpdk-dev: arch-dependent-file-in-usr-share
    These binaries are part of the sdk and meant to be shipped with the sdk.
  * d/p/dpdk-dev-doc-fix-old-dpdk-nic-bind.py-references.patch to fix the
    docs in regard to 16.07 changes renaming dpdk_nic_bind
  * d/p/make-load-devel-config-not-to-appear-as-executable.patch to avoid
    accidentally executing as script and to fix unusual-interpreter lintian
    warning.
  * fix d/t/test-initscripts on more recent systemd environments
  * enable dpdk for ppc64el

